/*
 * BaseFrame.java
 *
 * Created on 2. Juni 2006, 16:01
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package java2d2;

/**
 *
 * @author arnd
 */
import java.awt.*;
import java.awt.image.BufferedImage;
import java.awt.image.BufferedImageOp;
import java.awt.image.ColorConvertOp;
import java.awt.image.LookupOp;
import java.io.*;
import com.sun.image.codec.jpeg.*;

import java.awt.color.ColorSpace;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.image.ByteLookupTable;
import java.awt.image.LookupTable;
import javax.swing.JFrame;
public class BaseFrame extends JFrame {
    private static BufferedImage mImage;
    
    
    public BaseFrame()
    throws IOException, ImageFormatException {
        // Load the specified JPEG file.
        InputStream in=this.getClass().getResourceAsStream("image.jpg");
        JPEGImageDecoder decoder = JPEGCodec.createJPEGDecoder(in);
        mImage = decoder.decodeAsBufferedImage();
        in.close();
        
        setSize(mImage.getWidth(), mImage.getHeight());
        setLocation(200, 200);
        setVisible(true);
        setResizable(false);
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
        
    }
    public static BufferedImage convertToGrayscale(BufferedImage source) {
        BufferedImageOp op = new ColorConvertOp(ColorSpace.getInstance(ColorSpace.CS_GRAY), null);
        
        return op.filter(source, null);
        
    }
    
    public void paint(Graphics g) {
        
        Graphics2D g2 = (Graphics2D)g;
//GrayScaler
//      g2.drawImage(convertToGrayscale(mImage), 0, 0, null);
        
//KernelOps
//    	float zahl = 1.0f/9.0f;
//    	BufferedImageOp op = new ConvolveOp(new Kernel(3, 3, new float[]{ zahl, zahl, zahl, zahl, zahl, zahl, zahl, zahl, zahl }));
//    	g2.drawImage(mImage, op, 0, 0);
        
//Blautne
//       byte[] invert = new byte[256];
//       byte[] straight = new byte[256];
//       byte[] zero = new byte[256];
//       for (int i = 0; i < 256; i++)
//       {
//      		invert[i] = (byte)(255 - i);
//       		straight[i] = (byte)i;
//       		zero[i] = (byte)0;
//
//
//      }
//       byte[][] blueOnly = { zero, zero, straight };
//       LookupOp blau = new LookupOp(new ByteLookupTable(0, blueOnly), null);
//       g2.drawImage(mImage, blau, 0, 0);
        
//Threshold
        //BufferedImage grayImage = convertToRGB(convertToGrayscale(mImage));
        BufferedImage grayImage = convertToGrayscale(mImage);
        byte[] thresh = new byte[256];
        for (int i = 0; i < 256; i++) {
            if(i>100) {
                thresh[i] = (byte)0;
            } else{thresh[i] = (byte)i;}
        }
        LookupTable table = new ByteLookupTable(0, thresh);
        LookupOp threshOp = new LookupOp(table, null);
        g2.drawImage(grayImage, threshOp, 0, 0);
        
//Aufhellung
//       RescaleOp brighterOp = new RescaleOp(1.3f, 0, null);
//       g2.drawImage(mImage, brighterOp, 0, 0);
        
    }
    public static void main(String[] args) throws IOException, ImageFormatException  {
        
        new BaseFrame();
        
    }
    
}
